#include <stdio.h>
#include <string.h>

/* #include <libicb.h> */

#define LIB$K_PROC_VALUE_NULL 0
#define LIB$K_INVO_HANDLE_NULL 0
#define LIBICB$K_INVO_HANDLE_SIZE 4
#define LIBICB$K_INVO_CONTEXT_VERSION 1

#define LIBICB$M_FFLAGS_BITS 0xFFFFFF
#define LIBICB$M_EXCEPTION_FRAME 0x1
#define LIBICB$M_AST_FRAME 0x2
#define LIBICB$M_BOTTOM_OF_STACK 0x4
#define LIBICB$M_BASE_FRAME 0x8
#define LIBICB$K_INVO_CONTEXT_BLK_SIZE 544

static unsigned long invo_context_blk[LIBICB$K_INVO_CONTEXT_BLK_SIZE>>2];

extern void LIB$GET_CURR_INVO_CONTEXT(unsigned long *);
extern int LIB$GET_PREV_INVO_CONTEXT(unsigned long *);

#undef abort

void
kwk$abort (void)
{
  static int in_abort = 0;

  char *name;

  fflush (stdout);
  fprintf (stderr, "Aborting ...\n");
  fflush (stderr);

  if (in_abort)
    {
      fprintf (stderr, "recursive abort\n");
      fflush (stderr);
      return;
    }

  LIB$GET_CURR_INVO_CONTEXT (invo_context_blk);

  fprintf (stderr, "got invocation context\n");
  fflush (stderr);

  while (LIB$GET_PREV_INVO_CONTEXT (invo_context_blk))
    {
      name = (char *)invo_context_blk[2];
      name -= 8;
      name = (char *)(*((long long *)name));

      if ((name != 0)
	  && (*name >= 'A')
	  && (*name <= 'z'))
	fprintf (stderr, "[%08lx] %-30.30s: ", name, name);
      else
	fprintf (stderr, "[%08lx] %-30.30s: ", name, "<library>");

      fprintf (stderr, "Flags %08lx, Desc %08lx, PC %08lx\n",
	invo_context_blk[1], invo_context_blk[2], invo_context_blk[4]);
      if (strcmp (name, "main") == 0)
	break;
    }

  fprintf (stderr, "Exiting ...\n");
  fflush (stderr);

  decc$abort ();
  decc$exit (2);
}
